
/** TP 5ETI - CPE Lyon - 2011/2012 */

#include <scene.hpp>

#include <GL/glew.h>
#include <QString>
#include <QFont>
#include <glwidget.hpp>


#include <opengl_drawer.hpp>
#include <cmath>

using namespace cpe;



void scene::load_model()
{

    mesh_cat.load_file("data/cat.obj");
    mesh_cat.auto_scale(0.3);
    mesh_cat.compute_normal();
    texture_id_cat=p_widget->bindTexture(QString("data/cat.png"),GL_TEXTURE_2D);
    if(texture_id_cat==0)
        std::cout<<"Chargement texture echouee"<<std::endl;

    load_ground();

}

void scene::draw_scene()
{
    glEnable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);

    glColor3d(1,1,1);

    glBindTexture(GL_TEXTURE_2D,texture_id_cat);
    cpe::opengl_drawer::draw(mesh_cat);

    glBindTexture(GL_TEXTURE_2D,texture_id_ground);
    cpe::opengl_drawer::draw(mesh_ground);


}











scene::scene()
{
    //debug variables
    is_debug_mode=false;

    is_debug_vertex_index=true;
    is_debug_face_index=true;
    is_debug_inverted_normal=false;
    is_debug_draw_vertex=true;

    texture_id_cat=0;
    texture_id_ground=0;
}

void scene::load_ground()
{
    mesh_ground.add_vertex(v3(-1,-0.3,-1));
    mesh_ground.add_vertex(v3(-1,-0.3, 1));
    mesh_ground.add_vertex(v3( 1,-0.3, 1));
    mesh_ground.add_vertex(v3( 1,-0.3,-1));
    mesh_ground.add_triangle(0,1,2);
    mesh_ground.add_triangle(0,2,3);
    mesh_ground.add_texture(v2(0,0));
    mesh_ground.add_texture(v2(2,0));
    mesh_ground.add_texture(v2(2,2));
    mesh_ground.add_texture(v2(0,2));
    texture_id_ground=p_widget->bindTexture(QString("data/seamless_grass_texture.png"),GL_TEXTURE_2D);
    if(texture_id_ground==0)
        std::cout<<"Chargement texture echouee"<<std::endl;
    mesh_ground.compute_normal();
}




void scene::draw_debug(cpe::mesh& mesh_current)
{

    if(is_debug_mode==false)
        return ;

    double L_text=0.02;
    if(is_debug_inverted_normal==true)
        L_text*=-1;


    std::vector<v3> nv=mesh_current.get_normal_per_vertex();
    std::vector<v3> np=mesh_current.get_normal_per_polygon();

    glEnable(GL_LIGHTING);
    glEnable(GL_POLYGON_OFFSET_FILL);
    glPolygonOffset(5,5);



    glColor3d(0.5,0.1,0.0);

    glDisable(GL_POLYGON_OFFSET_FILL);
    glDisable(GL_LIGHTING);


    glColor3d(0.2,0.2,1);
    glPointSize(9.0);
    if(is_debug_draw_vertex==true)
    {
        glBegin(GL_POINTS);
        for(int k=0,N=mesh_current.number_of_vertices();k<N;++k)
        {
            const v3& p=mesh_current.vertex(k);
            glVertex3d(p.x(),p.y(),p.z());
        }
        glEnd();
    }

    std::vector<v3> p_index;
    std::vector<v3> translation_face;
    for(int k=0,N=mesh_current.number_of_vertices();k<N;++k)
        p_index.push_back(mesh_current.vertex(k)-nv[k]*L_text);
    for(int k=0,N=mesh_current.number_of_triangle();k<N;++k)
        translation_face.push_back(-L_text*np[k]);

    glColor3d(0,0,0);
    draw_index(p_index);
    glColor3d(1,0,0);
    draw_index_face(mesh_current,translation_face);
}

void scene::draw_index(const std::vector<cpe::v3>& x)
{
    if(is_debug_vertex_index==false)
        return ;

    int N=x.size();
    for(int k=0;k<N;++k)
        p_widget->draw_text(x[k][0],x[k][1],x[k][2],QString(k),QFont("Times",15,QFont::Normal));
}

void scene::draw_index_face(const cpe::mesh& mesh,const std::vector<v3>& translate)
{
    if(is_debug_face_index==false)
        return ;

    cpe::v3 x_bar;
    int N=mesh.number_of_triangle();
    for(int k=0;k<N;++k)
    {
        x_bar=(mesh.vertex_of_polygon(k,0)+mesh.vertex_of_polygon(k,1)+mesh.vertex_of_polygon(k,2))/3.0+translate[k];
        p_widget->draw_text(x_bar[0],x_bar[1],x_bar[2],QString(k),QFont("Times",15,QFont::Normal));
    }
}

void scene::set_glwidget(glwidget *_p_widget)
{
    p_widget=_p_widget;
}

void scene::set_is_debug_mode(bool value)
{
    is_debug_mode=value;
}

void scene::set_is_debug_vertex_index(bool value)
{
    is_debug_vertex_index=value;
}

void scene::set_is_debug_face_index(bool value)
{
    is_debug_face_index=value;
}

void scene::set_is_debug_inverted_normal(bool value)
{
    is_debug_inverted_normal=value;
}
void scene::set_is_debug_vertex_point(bool value)
{
    is_debug_draw_vertex=value;
}
