
/** TP 5ETI - CPE Lyon - 2011/2012 */


#ifndef _SCENE_HPP_
#define _SCENE_HPP_

#include <matrix3.hpp>
#include <v3.hpp>
#include <mesh.hpp>

#include <vector>

class glwidget;

class scene
{
public:

    scene();



    /** \brief Method called only once at the beginning (load off files ...) */
    void load_model();
    /** \brief Method called at every frame */
    void draw_scene();



    /** \brief Draw mesh in debug mode (draw indices) */
    void draw_debug(cpe::mesh& mesh_current);


    //debug variables
    void set_is_debug_mode(bool);
    void set_is_debug_vertex_index(bool);
    void set_is_debug_face_index(bool);
    void set_is_debug_inverted_normal(bool);
    void set_is_debug_vertex_point(bool);

    //set glwidget pointer
    void set_glwidget(glwidget *p_widget);

private:

    //*********************************//
    cpe::mesh mesh_cat;
    unsigned int texture_id_cat;

    cpe::mesh mesh_ground;
    unsigned int texture_id_ground;
    //*********************************//



    //*********************************//
    //internal methods
    //*********************************//
    void load_ground();


    bool is_debug_mode;
    bool is_debug_vertex_index;
    bool is_debug_face_index;
    bool is_debug_inverted_normal;
    bool is_debug_draw_vertex;
    void draw_index(const std::vector<cpe::v3>& x);
    void draw_index_face(const cpe::mesh& mesh,const std::vector<cpe::v3>& translate);
    glwidget *p_widget;

};

#endif
