#include "monWidgetGL.hpp"

#include <GL/glu.h>
#include <iostream>

monWidgetGL::monWidgetGL(QGLWidget *parent) :
    QGLWidget(parent)
{
    etat_affichage=true;
}

monWidgetGL::~monWidgetGL()
{}

void monWidgetGL::initializeGL()
{
    std::cout<<"appel monWidgetGL::initializeGL()"<<std::endl;

    glClearColor(1.0, 1.0, 1.0, 0.0);
    glEnable(GL_DEPTH_TEST);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-1.0f, 1.0f, -1.0f, 1.0f, -1.0f, 1.0f);
    gluPerspective(60,1.0,0.1,10.0);
    gluLookAt(0.0,0.0,2.0 , 0.0,0.0,-0.5 , 0.0,1.0,0.0);
}

void monWidgetGL::paintGL()
{
    std::cout<<"appel monWidgetGL::paintGL()"<<std::endl;

    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    if(etat_affichage==true)
    {
        glBegin(GL_TRIANGLES);
        glColor3d(1,0,0);
        glVertex3d(0,0,-0.5);
        glColor3d(0,1,0);
        glVertex3d(0.5,0,0.5);
        glColor3d(0,0,1);
        glVertex3d(0,0.5,0.5);
        glEnd();
    }


}



void monWidgetGL::afficher()
{
    etat_affichage=!etat_affichage;

    updateGL();
}
void monWidgetGL::wireframe(bool est_actif)
{
    if(est_actif==true)
        glPolygonMode( GL_FRONT_AND_BACK, GL_LINE);
    else
        glPolygonMode( GL_FRONT_AND_BACK, GL_FILL);

    updateGL();
}
